package Snafu;
import java.lang.*;
import java.net.*;
//   Snafu.java --- SMA de recherche d'information sur l'Internet

//   Copyright (C) 2000 Valvassori Mose <djedi@altern.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



/**
   La classe Agent principale.
   Elle sert de coquille pour tous les agents.

   @author Valvassori Mose
   @version alpha
 */
public abstract class SnafuAgent{
  /**
     @param nom le nom de l'agent
     @param abil  l'ability de l'agent
   */
  public SnafuAgent (String nom,String abil){
    name=nom;
    ID = new String(System.currentTimeMillis()+"");
    ability=abil;
    message = new SnafuKQML(getID(),getAbility(),this);
    message.start();
    System.runFinalizersOnExit(true); 
  }

  abstract protected void init();


  /**
     Accesseur de l'attribut ID
     @return la chaine contenant l'ID
     @see ID
  */
  public String getID(){
    return (new String (name+"."+ID));
  }
  
  /**
     L'<tt>ability</tt> dit ce qu'est capable de faire l'agent
     @return L'ability de l'Agent
   */
  public String getAbility(){
    return (ability);
  }


  protected void ajoute_canal(Socket s){
    message.recoit_canal(new SnafuAgentCanal(s,getID()),getAbility());
  }


  /**
     Destructeur de la Classe Agent
   */
  protected void finalize() throws Throwable {
System.out.println ("Destruction Agent"); // DEBUG
    message = null;
System.out.println ("Destruction Agent2"); // DEBUG
    super.finalize();
  }


  // ---- Attributs ------
  /**
    ID contient l'identificateur unique de l'agent.
    L'ID est compos d'un nom et d'un numro calcul 
    en fonction de l'horloge interne.
    @see getID
    @see SnafuAgent(String)
   */
  private String ID;
  private String name;
  private String ability;
  protected SnafuKQML message;
}

