package Snafu;
import java.net.*;
import java.io.*;
//   Snafu.java --- SMA de recherche d'information sur l'Internet

//   Copyright (C) 2000 Valvassori Mose <djedi@altern.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



/**
   Cette classe se cherge de maintenir un canal de communication entre
   deux agents. Ce thread reprsente un bout du canal. A l'autre bout, 
   il y a un autre thread qui apartient  un autre agent...
   @see SnafuAgent
   @see SnafuKQML   

   @author Valvassori Mose
   @version alpha
 */
public class SnafuAgentCanal extends Thread {
  public SnafuAgentCanal (Socket s,String id) {
    super("SnafuAgentCanal");		// Donne un petit nom au Thread
    System.out.println ("Canal cre: "+id); // DEBUG
    connection=s;
    ID=id;
    try{
      in = new BufferedReader(new InputStreamReader(connection.getInputStream()));
    } catch (IOException e){
      System.out.println ("Erreur **SnafuAgentCanal** :"+e);
    }    
  }



  /**
     Envoi une chaine dans la canal
     @param mesg Le massege  envoyer
  */
  public void envoyer(String mesg){
    try{
      PrintWriter out = new PrintWriter(connection.getOutputStream(), true);
      out.println(mesg);
    } catch (IOException e){
      System.out.println ("Erreur Canal Envoyer:"+e);
    }
  }



  public String recevoir(){
    String s=null;
    try{
      s=in.readLine();
    } catch (IOException e){
      System.out.println ("Erreur Canal recevoir:"+e);
      return null;
    }    
    return s;
  }


  /** 
      Prdicat qui indique si le canal a reu un message et si on peut le lire.
      @return false si le canal est vide, true sinon
   */
  public boolean pret(){
    try{
      return in.ready();
    } catch (IOException e){
      System.out.println ("Erreur Canal vide:"+e);
      return false;
    }    
  }

  //  public synchronized void run(){
  //    while(true){
  //      try{
  //  	if (in.ready()){
  //  	  notifyAll();
  //  	}
  //      }catch (IOException e){
  //  	System.out.println (""+e);
  //      }
  //      try{
  //  	sleep(10);
  //      } catch (InterruptedException e) {
  //  	System.out.println (""+e);
  //      }
  //    }
  //  }


  // --------------------
  private  BufferedReader in;
  private Socket connection;
  private String ID;
}
