//   SnafuYahoo.java --- Agent de recherche sur yahoo.com pour Snafu

//   Copyright (C) 2000 Valvassori Mose <djedi@altern.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package Snafu;
import java.net.*;
import java.io.*;


/**
   Dans cette classe, on retrouve l'interface utilisateur. Celle-ci
   est en mode texte. On rentre un mot cl et Snafu va le chercher.

   @author Valvassori Mose
   @version alpha
   @see SnafuAgentClient
 */
public class SnafuInterface extends SnafuAgentClient {
  public SnafuInterface() {
    super("SnafuInterfaceTexte","interface");
  }
  





  /**
     Reoit les messages et les traitent.
   */
  protected void run(){
    String messg;
    SnafuReponse repon;


System.out.println ("**********************");

    while (true){
      messg=message.recevoir();
      //      System.out.println ("Debug rec:"+message.getReceiver()); // DEBUG
      if ((message.getReceiver().equals("null")) || 
	  (message.getReceiver().equals(getID())) ||
	  (message.getReceiver().equals(getAbility()))){

	//	System.out.println ("Content:"+messg);	// DEBUG
	 if (message.getAction().equals("reply")){
	   repon = new SnafuReponse(messg);
	   System.out.println ("\n********************");
	   System.out.println ("** Nom: "+repon.getNom());
	   System.out.println ("** URL: "+repon.getAdresse());
	   System.out.println ("** Desc: "+repon.getDescription());
	 }
	 else 
	if (message.getAction().equals("tell")){
	  if (messg.equals("(end:)")){
	    System.out.println ("Perte d'un canal");
	  }
	}
      }
      message.amorce_reception();	// Dit  KQML que l'on est pret  recevoir un nouveau message
    } // Fin While
    
  }

  
  
  public static void main(String[] args){
    SnafuInterface client = new SnafuInterface();
    System.out.println (" Snafu version alpha, Copyright (C) 2000  Snafu Core \n    Snafu comes with ABSOLUTELY NO WARRANTY.\n    This is free software, and you are welcome to redistribute it\n    under certain conditions. (see LICENSE)\n"); 
    
    client.init();
    client.message.recevoir();		// Reoit l'ability du server...

    System.out.println ("Bonjour.");
    try{
      BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
      String ligne;

      System.out.println ("Que cherchez vous? ");
      ligne=in.readLine();
      System.out.println ("Recherche:"+ligne);

      client.message.init_entries();
      client.message.setContent(ligne);
      client.message.setReply_to("demande."+System.currentTimeMillis()); // Nom unique de la requte.
      client.message.setPerformative("achieve");
      client.message.setReceiver("server");
      client.message.envoyer();
    } catch (IOException e){
      System.out.println ("Erreur de lecture: " + e);
    }

    client.message.amorce_reception();
    System.out.println (""+client.message.recevoir());
    System.out.println (""+client.message.getReceiver());
    client.message.amorce_reception();

    client.run();

    // Gnrique de Fin
    if (client.message.message_attente())
      try{
	System.out.println ("Vide les canaux.");
	Thread.sleep(1000);
      } catch (InterruptedException e){
	
      }
    client = null;
    System.out.println ("Bye...");
    System.exit(0);
  }

  protected void finalize () throws Throwable {
    super.finalize();
  }
}




