//   SnafuReponse.java --- SMA de recherche d'information sur l'Internet

//   Copyright (C) 2000 Valvassori Mose <djedi@altern.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package Snafu;
import java.lang.*;
import java.net.*;
import gnu.regexp.*;

/**
   Cette classe spcifie les rponses qui seront renvoy par 
   les agents de recheche. Elle contient trois champs:<ul>
    <li><tt>nom</tt> le nom du document trouv
    <li><tt>adresse</tt> Son url
    <li><tt>description</tt> la desciption du document.
    </ul>

   @see SnafuKQML
   @author Valvassori Mose
   @version alpha
 */
public class SnafuReponse {
  public SnafuReponse(){
    nom = null;
    adresse = null;
    description = null;
  }
  public SnafuReponse(String n,URL a){
    nom=n;
    adresse=a;
  }
  public SnafuReponse(String n,URL a,String d){
    nom=n;
    adresse=a;
    description=d;
  }

  /**
     Construit une rponse  partir d'une chaine. C'est la fonction
     inverse de <tt>toString</tt>.
     @see #toString()
   */
  public SnafuReponse(String s){

    if (s != null)
      try{
	RE begining = new RE("^\\((.*)\\)");
	RE couples  = new RE(":([a-zA-Z-]+)[ \n]+([^\\)]*)");
	REMatch match = begining.getMatch(s);
	if (match == null) 
	  {
	    System.out.println ("NO Match");
	  }
	else {
	  // Rcupration des couples  :nom valeur 
	  REMatch [] matches = couples.getAllMatches(s);
	  for (int i = 0; i < matches.length; i++)
	    {
	      if (matches[i].toString(1).equals("name"))
		{
		  nom = parenthese(matches[i].toString(2));
		}
	      else if (matches[i].toString(1).equals("description"))
		{
		  description = parenthese(matches[i].toString(2));
		}
	      else if (matches[i].toString(1).equals("url"))
		{
		  try{
		    adresse = new URL(matches[i].toString(2));
		  } catch (MalformedURLException e){
		    System.out.println ("URL MAl Forme:" + e);
		  }
		}
	    }
	}
      } catch (REException e){
	System.out.println("Erreur dans l'expression rguliere: "+e);
      }
  }

  // --- Accesseurs ---
  public String getNom(){
    return(nom);
  }
  public URL getAdresse(){
    return(adresse);
  }
  public String getDescription(){
    return(description);
  }



  /**
     Encode la reponse de faon  tre enfil dans un objet
     KQML.
   */
  public String toString(){
    try{
      RE op = new RE("\\(");
      RE cp = new RE ("\\)");
      String n = op.substituteAll(nom,op2); // encode les ( )
      n = cp.substituteAll(n,cp2);
      String d = op.substituteAll(description,op2);
      d = cp.substituteAll(d,cp2);
      return new String("(:name "+n+" :url "+adresse+" :description "+d+")");
    } catch (REException e){
      System.out.println("Erreur dans l'expression rguliere: "+e);
      return null;
    }
  }


  private String parenthese(String s){
    try{
      RE op = new RE(cp2);
      String n = op.substituteAll(s,")");
      op = new RE(op2);
      n = op.substituteAll(n,"(");
      return n;
    } catch (REException e){
      System.out.println("Erreur dans l'expression rguliere: "+e);
      return null;
    }    
  }

  //  ---------------------
  private String nom;
  private URL    adresse;
  private String description;
  private static final String op2 = "";
  private static final String cp2 = "";
}
