//   SnafuYahoo.java --- Agent de recherche sur yahoo.com pour Snafu

//   Copyright (C) 2000 Valvassori Mose <djedi@altern.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package Snafu;
import java.net.*;
import java.io.*;
import java.util.*;
import gnu.regexp.*;


/**
   Cette classe effectue une recherche sur yahoo.

   @author Valvassori Mose
   @version alpha
*/
public class SnafuYahoo extends SnafuAgentClient {
  public SnafuYahoo() {
    super("SnafuYahoo","search");
    reponses = new Vector();
  }


  static public void main(String[] args){
    SnafuYahoo y = new SnafuYahoo();
    System.out.println ("--- "+y.getID());
    y.init();
    y.run();
    y.recherche("Boo");

    System.exit(0);
  }
  



  /**
     Reoit les messages et les traitent.
   */
  protected void run(){
    String messg;
    SnafuReponse repon;


    while (true){
      messg=message.recevoir();
      //      System.out.println ("Debug rec:"+message.getReceiver()); // DEBUG
      if ((message.getReceiver().equals("null")) || 
	  (message.getReceiver().equals(getID())) ||
	  (message.getReceiver().equals(getAbility()))){

	//	System.out.println ("Content:"+messg);	// DEBUG
	if (message.getAction().equals("tell")){
	  if (messg.equals("(end:)")){
	    System.out.println ("Perte d'un canal");
	  }
	}
	else if (message.getAction().equals("achieve")){
	  String reply_to=message.getReply_to();
	  recherche(messg);
	  // J'envoie les rponses au  l'expditeur.
	  // Normalement, si j'ai le temps, je devrais enlever
	  // les doublons. C'est pour ca que c'est en dehors de 
	  // la boucle.
	  for (int i=0; i<reponses.size(); i++){
	    message.init_entries();
	    message.setContent(reponses.elementAt(i).toString());
	    message.setIn_reply_to(reply_to);
	    message.setPerformative("reply");
	    message.envoyer();
	  }
	}
      }
      message.amorce_reception();	// Dit  KQML que l'on est pret  recevoir un nouveau message
    } // Fin While
    
  }






  /**
     Effectue la recherche proprement dites.

     Ouvre une page web. Puis cherche les patterns qui correspondent
      une entre. Un fois les champs extraits, on les place dans des 
     reponses que l'on range dans un vector.
     @param search la chaine que l'on recherche


     @author Valvassori Mose
     @version prealpha
   */
  public void recherche(String search){

    if (!reponses.isEmpty())
      reponses.removeAllElements();

     try{
       URL url= new URL("http://fr.search.yahoo.com/search/fr?p="+search);
       BufferedReader in = 
	 // 	 new BufferedReader(new FileReader ("snafu/agent.html"));
	 new BufferedReader(new InputStreamReader(url.openStream()));	      

       String inputLine;

       System.out.println ("[");
//////////////////////////////////////////////////////////////////////////////////
//   Cette partie est un peu lourde. En gros, on lit chaque ligne. 	        //
//   Pour chaque ligne, on regarde si elle matche avec une des regexeps	        //
//   Si c'est la cas, on range les divers constituant dans le vecteur	        //
//  de rponses								        //
//////////////////////////////////////////////////////////////////////////////////
       while ((inputLine = in.readLine()) != null)			       
	 try{
	   System.out.println (".");
	   RE regexp= new RE(oneline);
	   REMatch m = regexp.getMatch(inputLine);
	   if (m!=null)
	     try{
	     reponses.addElement(new SnafuReponse(m.substituteInto("$3"),
						 new URL(m.substituteInto("$2")),
						 m.substituteInto("$5")));
	     }catch (MalformedURLException e){
	       System.out.println ("URL mal Form: "+ e);
	     }
	   else {			// ici m == null
	     regexp = new RE(twoline1);
	     m = regexp.getMatch(inputLine);
	     if (m!=null) 
	       try {
		 String titre = m.substituteInto("$2");
		 URL urltmp = new URL(m.substituteInto("$1"));
		 inputLine = in.readLine();
		 regexp= new RE(twoline2);
		 m = regexp.getMatch(inputLine);
		 if (m != null){
		   reponses.addElement(new SnafuReponse(titre,urltmp,
					   m.substituteInto("$1")));
		 }
	       } catch (MalformedURLException e){
		 System.out.println ("URL mal Form: "+ e);
	       }

	   } // Fin du else
	     
	   System.out.println ("]");
	 } catch (REException e){	// Fin du while ((inputLine = ...
	   System.out.println("Erreur dans l'expression rguliere: "+e);
	   System.exit(-1);       
	 }
       in.close();

     } catch (FileNotFoundException e){
       System.out.println("On ne peut pas ouvrir le fichier: "+e);
       System.exit(-1);
     } catch (IOException e){
       System.out.println("IOException: "+e);
       System.exit(-1);
     }
     //  } catch (MalformedURLException e){
     //    System.out.println ("URL mal Form: "+ e);
     //  }
  }


  //  ----------------------------------------
  /**
     Cette regexp match une entre de la forme
     <pre>
     <a href=" URL "> Titre </a> - Description <li> ou </ul>
     </pre>
     @see recherche
  */
  private static final String oneline = "<(a href|A HREF)=\"(.*)\">(.*)</(a|A)> - (.*)(<LI>$|<li>$|</UL>|</ul>)";
  private static final String twoline1 = "<LI><A HREF=\"(.*)\">(.*)</A>$"; 
  private static final String twoline2 = " - (.*)(<LI>$|<li>$|</UL>|</ul>)";
  
  /**
     Ce vector contient la liste des rponses qui vont tre renvoy
     
   */
  private Vector reponses;
}


  /// Old Version - DJedi ///////////////////////////////////////////////////////
  //  public void recherche(){						       //
  //    BufferedReader in = 						       //
  //      new BufferedReader(new InputStreamReader(url.openStream()));	       //
  //    								       //
  //    String inputLine;						       //
  //    								       //
  //    while ((inputLine = in.readLine()) != null)			       //
  //      System.out.println(inputLine);				       //
  //    								       //
  //    in.close();							       //
  //  }									       //
  ///////////////////////////////////////////////////////////////////////////////
